#! /usr/bin/env python
# encoding: utf-8
import sys
if sys.hexversion < 0x020400f0: from sets import Set as set
import sys,random,time,threading,Queue,traceback
import Build,Utils,Logs,Options
import pproc
from Logs import debug,error
from Constants import*
def print_log(msg,nl='\n'):
	f=Build.bld.log
	if f:
		f.write(msg)
		f.write(nl)
		f.flush()
def printout(s):
	if not Build.bld.log:
		sys.stdout.write(s)
		sys.stdout.flush()
	print_log(s,nl='')
def exec_command(s,shell=1):
	debug('runner: system command -> %s'%s)
	log=Build.bld.log
	if log or Logs.verbose:printout(s+'\n')
	proc=pproc.Popen(s,shell=shell,stdout=log,stderr=log)
	return proc.wait()
if sys.platform=="win32":
	old_log=exec_command
	def exec_command(s,shell=1):
		if len(s)<2000:return old_log(s,shell=shell)
		log=Build.bld.log
		if log or Logs.verbose:printout(s+'\n')
		startupinfo=pproc.STARTUPINFO()
		startupinfo.dwFlags|=pproc.STARTF_USESHOWWINDOW
		proc=pproc.Popen(s,shell=False,startupinfo=startupinfo)
		return proc.wait()
class TaskConsumer(threading.Thread):
	def __init__(self,m):
		threading.Thread.__init__(self)
		self.setDaemon(1)
		self.master=m
		self.start()
	def run(self):
		m=self.master
		while 1:
			tsk=m.ready.get()
			if m.stop:
				m.out.put(tsk)
				continue
			try:
				printout(tsk.display())
				if tsk.__class__.stat:ret=tsk.__class__.stat(tsk)
				else:ret=tsk.call_run()
			except Exception,e:
				tsk.err_msg=e.message
				tsk.hasrun=EXCEPTION
				m.error_handler(tsk)
				m.out.put(tsk)
				continue
			if ret:
				tsk.err_code=ret
				tsk.hasrun=CRASHED
			else:
				try:
					tsk.post_run()
				except OSError:
					tsk.hasrun=MISSING
				else:
					tsk.hasrun=SUCCESS
			if tsk.hasrun!=SUCCESS:
				m.error_handler(tsk)
			m.out.put(tsk)
class Parallel(object):
	def __init__(self,bld,j=2):
		self.numjobs=j
		self.manager=bld.task_manager
		self.total=self.manager.total()
		self.outstanding=[]
		self.maxjobs=sys.maxint
		self.frozen=[]
		self.ready=Queue.Queue(0)
		self.out=Queue.Queue(0)
		self.count=0
		self.processed=0
		self.consumers=None
		self.stop=False
		self.error=False
	def get_next(self):
		return self.outstanding.pop(0)
	def postpone(self,tsk):
		if random.randint(0,1):
			self.frozen.insert(0,tsk)
		else:
			self.frozen.append(tsk)
	def refill_task_list(self):
		while self.count>self.numjobs+5:
			self.get_out()
		self.outstanding=self.frozen
		self.frozen=[]
		if not self.outstanding:
			while self.count>0:self.get_out()
			(self.maxjobs,self.outstanding)=self.manager.get_next_set()
	def get_out(self):
		self.manager.add_finished(self.out.get())
		self.count-=1
	def error_handler(self,tsk):
		if not Options.options.keep:
			self.stop=True
		self.error=True
	def start(self):
		while not self.stop:
			while self.count>=self.maxjobs:
				self.get_out()
			if not self.outstanding:
				self.refill_task_list()
				if self.maxjobs is None:
					break
			tsk=self.get_next()
			if tsk.hasrun:
				self.processed+=1
				self.manager.add_finished(tsk)
			try:
				st=tsk.runnable_status()
			except Exception,e:
				tsk.err_msg="TODO print the exception here"
				tsk.hasrun=EXCEPTION
				self.error_handler(tsk)
			if st==ASK_LATER:
				self.postpone(tsk)
			elif st==SKIP_ME:
				self.processed+=1
				tsk.hasrun=SKIPPED
				self.manager.add_finished(tsk)
			else:
				tsk.position=(self.processed,self.total)
				self.count+=1
				self.ready.put(tsk)
				self.processed+=1
				if not self.consumers:
					self.consumers=[TaskConsumer(self)for i in xrange(self.numjobs)]
		while self.count:
			self.get_out()

