#! /usr/bin/env python
# encoding: utf-8

import select,errno,os,time
module=None
def check_support():
	try:
		import gamin
	except ImportError:
		pass
	else:
		try:
			test=gamin.WatchMonitor()
			test.disconnect()
			test=None
		except:
			pass
		else:
			module=gamin
	try:
		import _fam
	except ImportError:
		support=False
	else:
		try:
			test=_fam.open()
			test.close()
			test=None
		except:
			pass
		else:
			module=_fam
g_daemonlock=0
def call_back(idxName,pathName,event):
	global g_daemonlock
	if g_daemonlock:return
	g_daemonlock=1
	try:
		main()
	except Utils.WafError,e:
		error(e)
	g_daemonlock=0
def start_daemon():
	global g_dirwatch
	if not g_dirwatch:
		g_dirwatch=DirectoryWatcher()
		dirs=[]
		for nodeDir in Build.bld.srcnode.dirs():
			tmpstr="%s"%nodeDir
			tmpstr="%s"%(tmpstr[6:])
			dirs.append(tmpstr)
		g_dirwatch.add_watch("tmp Test",call_back,dirs)
		g_dirwatch.loop()
		g_dirwatch=None
	else:
		g_dirwatch.suspend_all_watch()
		dirs=[]
		for nodeDir in Build.bld.srcnode.dirs():
			tmpstr="%s"%nodeDir
			tmpstr="%s"%(tmpstr[6:])
			dirs.append(tmpstr)
		g_dirwatch.add_watch("tmp Test",call_back,dirs)
class WatchObject:
	def __init__(self,idxName,namePath,isDir,callBackThis,handleEvents):
		self._adaptor=None
		self._fr=None
		self._idxName=idxName
		self._name=namePath
		self._isDir=isDir
		self._callBackThis=callBackThis
		self._handleEvents=handleEvents
	def __del__(self):
		self.unwatch()
	def watch(self,adaptor):
		self._adaptor=adaptor
		if self._fr!=None:
			self.unwatch()
		if self._isDir:
			self._fr=self._adaptor.watch_directory(self._name,self._idxName)
		else:
			self._fr=self._adaptor.watch_file(self._name,self._idxName)
	def unwatch(self):
		if self._fr:
			self._fr=self._adaptor.stop_watch(self._name)
	def get_events(self):
		return self._handleEvents
	def get_callback(self):
		return self._callBackThis
	def get_fullpath(self,fileName):
		return os.path.join(self._name,fileName)
	def __str__(self):
		if self._isDir:
			return'DIR %s: '%self._name
		else:
			return'FILE %s: '%self._name
class DirectoryWatcher:
	def __init__(self):
		self._adaptor=None
		self._watcher={}
		self._loops=True
		self.connect()
	def __del__(self):
		self.disconnect()
	def _raise_disconnected(self):
		raise"Already disconnected"
	def disconnect(self):
		if self._adaptor:
			self.suspend_all_watch()
		self._adaptor=None
	def connect(self):
		if self._adaptor:
			self.disconnect()
		global module
		if not module:
			self.check_support()
		if module.__name__=="fam":
			self._adaptor=FamAdaptor(self._processDirEvents)
		elif module.__name__=="gamin":
			self._adaptor=GaminAdaptor(self._processDirEvents)
		else:
			self._adaptor=FallbackAdaptor(self._processDirEvents)
	def add_watch(self,idxName,callBackThis,dirList,handleEvents=['changed','deleted','created']):
		self.remove_watch(idxName)
		self._watcher[idxName]=[]
		for directory in dirList:
			watchObject=WatchObject(idxName,os.path.abspath(directory),1,callBackThis,handleEvents)
			self._watcher[idxName].append(watchObject)
		self.resume_watch(idxName)
	def remove_watch(self,idxName):
		if self._watcher.has_key(idxName):
			self.suspend_watch(idxName)
			del self._watcher[idxName]
	def remove_all_watch(self):
		self._watcher={}
	def suspend_watch(self,idxName):
		if self._watcher.has_key(idxName):
			for watchObject in self._watcher[idxName]:
				watchObject.unwatch()
	def suspend_all_watch(self):
		for idxName in self._watcher.keys():
			self.suspend_watch(idxName)
	def resume_watch(self,idxName):
		for watchObject in self._watcher[idxName]:
			watchObject.watch(self._adaptor)
	def resume_all_watch(self):
		for idxName in self._watcher.keys():
			self.resume_watch(idxName)
	def _processDirEvents(self,pathName,event,idxName):
		if event in self._watcher[idxName][0].get_events():
			self.suspend_watch(idxName)
			_watcher=self._watcher[idxName][0]
			_watcher.get_callback()(idxName,_watcher.get_fullpath(pathName),event)
			self.resume_watch(idxName)
	def request_end_loop(self):
		self._loops=False
	def loop(self):
		try:
			self._loops=True
			while self._loops and self._adaptor!=None:
				self._adaptor.wait_for_event()
				while self._adaptor.event_pending():
					self._adaptor.handle_events()
					if not self._loops:
						break
		except KeyboardInterrupt:
			self.request_end_loop()
class adaptor(object):
	def __init__(self,event_handler):
		self.event_handler=event_handler
		self.watch_handler={}
	def __del__(self):
		if self.data:
			for handle in self.watch_handler.keys():
				self.stop_watch(handle)
	def event_pending(self):
		self.check_init()
		return self.data.event_pending()
	def watch_directory(self,name,idxName):
		self.check_init()
		if self.watch_handler.has_key(name):
			raise"dir already watched"
		self.watch_handler[name]=self.do_watch_directory(name,idxName)
		return self.watch_handler[name]
	def watch_file(self,name,idxName):
		self.check_init()
		if self.watch_handler.has_key(name):
			raise"file already watched"
		self.watch_handler[name]=self.do_watch_file(name,idxName)
		return self.watch_handler[name]
	def stop_watch(self,name):
		self.check_init()
		if self.watch_handler.has_key(name):
			self.do_stop_watch(name)
			del self.watch_handler[name]
		return None
	def handle_events(self):
		self.check_init()
		self.data.handle_events()
	def check_init(self):
		if not self.data:
			raise OSError,"Adapter not initialized"
class FamAdaptor(DirWatch.adaptor):
	def __init__(self,event_handler):
		DirWatch.adaptor.__init__(self,event_handler)
		global module
		self.data=module.open()
	def __del__(self):
		DirWatch.adaptor.__del__(self)
		if self.data:self.data.close()
	def do_add_watch_dir(self,name,idx_name):
		return self.data.monitorDirectory(name,idxName)
	def do_add_watch_file(self,name,idx_name):
		return self.data.monitorFile(name,idxName)
	def do_stop_watch(self,name):
		self.watch_handler[name].cancelMonitor()
	def wait_for_event(self):
		self.check_init()
		try:
			select.select([self.data],[],[])
		except select.error,er:
			errnumber,strerr=er
			if errnumber!=errno.EINTR:
				raise strerr
	def handle_events(self):
		self.check_init()
		fe=self.data.nextEvent()
		self._eventHandler(fe.filename,fe.code2str(),fe.userData)
class GaminAdaptor(adaptor):
	def __init__(self,eventHandler):
		adaptor.__init__(self,event_handler)
		global module
		self.data=module.WatchMonitor()
	def __del__(self):
		adaptor.__del__(self)
		if self.data:self.data.disconnect()
	def check_init(self):
		if self._gamin==None:
			raise"gamin not init"
	def _code2str(self,event):
		gaminCodes={1:"changed",2:"deleted",3:"StartExecuting",4:"StopExecuting",5:"created",6:"moved",7:"acknowledge",8:"exists",9:"endExist"}
		try:
			return gaminCodes[event]
		except KeyError:
			return"unknown"
	def _eventhandler_helper(self,pathName,event,idxName):
		self._eventHandler(pathName,self._code2str(event),idxName)
	def do_add_watch_dir(self,name,idx_name):
		return self.data.watch_directory(name,self._eventhandler_helper,idxName)
	def do_add_watch_file(self,name,idx_name):
		return self.data.watch_directory(name,self._eventhandler_helper,idxName)
	def do_stop_watch(self,name):
		self.data.stop_watch(name)
	def wait_for_event(self):
		self.check_init()
		try:
			select.select([self._gamin.get_fd()],[],[])
		except select.error,er:
			errnumber,strerr=er
			if errnumber!=errno.EINTR:
				raise strerr
class Fallback:
	class Helper:
		def __init__(self,callBack,userdata):
			self.currentFiles={}
			self.oldFiles={}
			self._firstRun=True
			self.callBack=callBack
			self.userdata=userdata
		def isFirstRun(self):
			if self._firstRun:
				self._firstRun=False
				return True
			else:
				return False
	def __init__(self):
		self._dirs={}
		self._changeLog={}
	def _traversal(self,dirName):
		files=os.listdir(dirName)
		firstRun=self._dirs[dirName].isFirstRun()
		for filename in files:
			path=os.path.join(dirName,filename)
			try:
				fileStat=os.stat(path)
			except os.error:
				continue
			modifyTime=self._dirs[dirName].oldFiles.get(path)
			if modifyTime is not None:
				del self._dirs[dirName].oldFiles[path]
				if fileStat.st_mtime>modifyTime:
					self._changeLog[path]='changed'
			else:
				if firstRun:
					self._changeLog[path]='exists'
				else:
					self._changeLog[path]='created'
			self._dirs[dirName].currentFiles[path]=fileStat.st_mtime
	def watch_directory(self,namePath,callBack,idxName):
		self._dirs[namePath]=self.Helper(callBack,idxName)
		return self
	def unwatch_directory(self,namePath):
		if self._dirs.get(namePath):
			del self._dirs[namePath]
	def event_pending(self):
		for dirName in self._dirs.keys():
			self._dirs[dirName].oldFiles=self._dirs[dirName].currentFiles.copy()
			self._dirs[dirName].currentFiles={}
			self._traversal(dirName)
			for deletedFile in self._dirs[dirName].oldFiles.keys():
				self._changeLog[deletedFile]='deleted'
				del self._dirs[dirName].oldFiles[deletedFile]
		return len(self._changeLog)
	def handle_events(self):
		pathName=self._changeLog.keys()[0]
		event=self._changeLog[pathName]
		dirName=os.path.dirname(pathName)
		self._dirs[dirName].callBack(pathName,event,self._dirs[dirName].userdata)
		del self._changeLog[pathName]
class FallbackAdaptor(DirWatch.adaptor):
	def __init__(self,eventHandler):
		DirWatch.adaptor.__init__(self,event_handler)
		self.data=Fallback()
	def do_add_watch_dir(self,name,idx_name):
		return self.data.watch_directory(name,self._eventHandler,idxName)
	def do_add_watch_file(self,name,idx_name):
		return self.data.watch_directory(name,self._eventHandler,idxName)
	def do_stop_watch(self,name):
		self.data.unwatch_directory(name)
	def wait_for_event(self):
		self.check_init()
		time.sleep(1)

