#! /usr/bin/env python
# encoding: utf-8

EXT_C=['.c','.cc','.cpp','.cxx']
import shutil,os
import TaskGen,Task,ccroot,Build
from TaskGen import extension
from Constants import*
class TaskMaster(Task.Task):
	def __init__(self,action_name,env,normal=1,master=None):
		Task.Task.__init__(self,env,normal=normal)
		self.slaves=[]
		self.inputs2=[]
		self.outputs2=[]
	def add_slave(self,slave):
		self.slaves.append(slave)
		self.set_run_after(slave)
	def runnable_status(self):
		for t in self.run_after:
			if not t.hasrun:return ASK_LATER
		for t in self.slaves:
			self.inputs.append(t.inputs[0])
			self.outputs.append(t.outputs[0])
			if t.must_run:
				self.inputs2.append(t.inputs[0])
				self.outputs2.append(t.outputs[0])
		return Task.Task.runnable_status(self)
	def run(self):
		tmpinputs=self.inputs
		self.inputs=self.inputs2
		tmpoutputs=self.outputs
		self.outputs=self.outputs2
		ret=self.action.run(self)
		env=self.env
		rootdir=Build.bld.srcnode.abspath(env)
		for i in self.outputs:
			name=i.name
			if name[-1]=="s":name=name[:-1]
			shutil.move(name,i.bldpath(env))
		self.inputs=tmpinputs
		self.outputs=tmpoutputs
		return ret
class TaskSlave(Task.Task):
	def __init__(self,action_name,env,normal=1,master=None):
		Task.Task.__init__(self,env,normal)
		self.master=master
	def prepare(self):
		self.display="* skipping "+self.inputs[0].name
	def update_stat(self):
		self.executed=1
	def runnable_status(self):
		self.must_run=Task.Task.must_run(self)
		return self.must_run
	def run(self):
		return 0
	def can_retrieve_cache(self,sig):
		return None
def create_task_cxx_new(self,node):
	try:
		mm=self.mastertask
	except AttributeError:
		mm=TaskMaster("all_"+self.type_initials,self.env)
		self.mastertask=mm
	task=TaskSlave(self.type_initials,self.env,40,master=mm)
	self.tasks.append(task)
	mm.add_slave(task)
	task.set_inputs(node)
	task.set_outputs(node.change_ext('.o'))
	self.compiled_tasks.append(task)
cc_str='${CC} ${CCFLAGS} ${CPPFLAGS} ${_CCINCFLAGS} ${_CCDEFFLAGS} -c ${SRC}'
Task.simple_task_type('all_cc',cc_str,'GREEN')
cpp_str='${CXX} ${CXXFLAGS} ${CPPFLAGS} ${_CXXINCFLAGS} ${_CXXDEFFLAGS} -c ${SRC}'
Task.simple_task_type('all_cpp',cpp_str,color='GREEN')

extension(EXT_C)(create_task_cxx_new)
