#! /usr/bin/env python
# encoding: utf-8

import os,re
import TaskGen,Utils,Runner,Task,Build,Options,Logs
import cc
from Logs import error
from TaskGen import taskgen,before,after,feature
n1_regexp=re.compile('<refentrytitle>(.*)</refentrytitle>',re.M)
n2_regexp=re.compile('<manvolnum>(.*)</manvolnum>',re.M)
def postinstall_schemas(prog_name):
	if Options.commands['install']:
		dir=Build.bld.get_install_path('${PREFIX}/etc/gconf/schemas/%s.schemas'%prog_name)
		if not Options.options.destdir:
			Utils.pprint('YELLOW','Installing GConf schema')
			command='gconftool-2 --install-schema-file=%s 1> /dev/null'%dir
			ret=Runner.exec_command(command)
		else:
			Utils.pprint('YELLOW','GConf schema not installed. After install, run this:')
			Utils.pprint('YELLOW','gconftool-2 --install-schema-file=%s'%dir)
def postinstall_icons():
	dir=Build.bld.get_install_path('${DATADIR}/icons/hicolor')
	if Options.commands['install']:
		if not Options.options.destdir:
			Utils.pprint('YELLOW',"Updating Gtk icon cache.")
			command='gtk-update-icon-cache -q -f -t %s'%dir
			ret=Runner.exec_command(command)
		else:
			Utils.pprint('YELLOW','Icon cache not updated. After install, run this:')
			Utils.pprint('YELLOW','gtk-update-icon-cache -q -f -t %s'%dir)
def postinstall_scrollkeeper(prog_name):
	if Options.commands['install']:
		if os.path.iswriteable('/var/log/scrollkeeper.log'):
			dir1=Build.bld.get_install_path('${PREFIX}/var/scrollkeeper')
			dir2=Build.bld.get_install_path('${DATADIR}/omf/%s'%prog_name)
			command='scrollkeeper-update -q -p %s -o %s'%(dir1,dir2)
			ret=Runner.exec_command(command)
def postinstall(prog_name='myapp',schemas=1,icons=1,scrollkeeper=1):
	if schemas:postinstall_schemas(prog_name)
	if icons:postinstall_icons()
	if scrollkeeper:postinstall_scrollkeeper(prog_name)
class gnome_doc_taskgen(TaskGen.task_gen):
	def __init__(self,*k):
		TaskGen.task_gen.__init__(self,*k)
		self.default_install_path='${PREFIX}/share'
	def apply(self):
		self.env['APPNAME']=self.doc_module
		lst=self.to_list(self.doc_linguas)
		for x in lst:
			tsk=self.create_task('xml2po')
			node=self.path.find_resource(x+'/'+x+'.po')
			src=self.path.find_resource('C/%s.xml'%self.doc_module)
			out=self.path.find_or_declare('%s/%s.xml'%(x,self.doc_module))
			tsk.set_inputs([node,src])
			tsk.set_outputs(out)
			tsk2=self.create_task('xsltproc2po')
			out2=self.path.find_or_declare('%s/%s-%s.omf'%(x,self.doc_module,x))
			tsk2.set_outputs(out2)
			node=self.path.find_resource(self.doc_module+".omf.in")
			tsk2.inputs=[node,out]
			tsk2.run_after.append(tsk)
			if Options.is_install:
				path=self.install_path+'gnome/help/%s/%s'%(self.doc_module,x)
				Build.bld.install_files(self.install_path+'omf',out2.abspath(self.env))
				for y in self.to_list(self.doc_figures):
					try:
						os.stat(self.path.abspath()+'/'+x+'/'+y)
						Common.install_as(path+'/'+y,self.path.abspath()+'/'+x+'/'+y)
					except:
						Common.install_as(path+'/'+y,self.path.abspath()+'/C/'+y)
				Common.install_as(path+'/%s.xml'%self.doc_module,out.abspath(self.env))
class xml_to_taskgen(TaskGen.task_gen):
	def __init__(self):
		TaskGen.task_gen(self)
		self.source='xmlfile'
		self.xslt='xlsltfile'
		self.target='hey'
		self.default_install_path='${PREFIX}'
		self.task_created=None
	def apply(self):
		self.env=self.env.copy()
		tree=Build.bld
		xmlfile=self.path.find_resource(self.source)
		xsltfile=self.path.find_resource(self.xslt)
		tsk=self.create_task('xmlto')
		tsk.set_inputs([xmlfile,xsltfile])
		tsk.set_outputs(xmlfile.change_ext('html'))
		tsk.install_path=self.install_path
def sgml_scan(self):
	node=self.inputs[0]
	env=self.env
	variant=node.variant(env)
	fi=open(node.abspath(env),'r')
	content=fi.read()
	fi.close()
	name=n1_regexp.findall(content)[0]
	num=n2_regexp.findall(content)[0]
	doc_name=name+'.'+num
	return([],[doc_name])
def sig_implicit_deps(self):
	def sgml_outputs():
		dps=Build.bld.raw_deps[self.unique_id()]
		name=dps[0]
		self.set_outputs(self.task_generator.path.find_or_declare(name))
	tree=Build.bld
	key=self.unique_id()
	prev_sigs=tree.task_sigs.get(key,())
	if prev_sigs and prev_sigs[2]==self.compute_sig_implicit_deps():
		sgml_outputs()
		return prev_sigs[2]
	(nodes,names)=self.scan()
	if Logs.verbose and Logs.zones:
		debug('deps: scanner for %s returned %s %s'%(str(self),str(nodes),str(names)))
	tree=Build.bld
	tree.node_deps[self.unique_id()]=nodes
	tree.raw_deps[self.unique_id()]=names
	sgml_outputs()
	sig=self.compute_sig_implicit_deps()
	return sig
class gnome_sgml2man_taskgen(TaskGen.task_gen):
	def __init__(self,*k,**kw):
		TaskGen.task_gen.__init__(self)
		self.tasks=[]
		self.appname=k[0]
	def apply(self):
		def install_result(task):
			out=task.outputs[0]
			name=out.name
			ext=name[-1]
			env=task.env
			Build.bld.install_files('DATADIR','man/man%s/'%ext,out.abspath(env),env)
		tree=Build.bld
		tree.rescan(self.path)
		for name in Build.bld.cache_dir_contents[self.path.id]:
			base,ext=os.path.splitext(name)
			if ext!='.sgml':continue
			task=self.create_task('sgml2man')
			task.set_inputs(self.path.find_resource(name))
			task.task_generator=self
			if Options.is_install:task.install=install_result
			task.scan()
def add_marshal_file(self,filename,prefix,mode):
	if not hasattr(self,'marshal_lst'):self.marshal_lst=[]
	self.meths.append('process_marshal')
	self.marshal_lst.append([filename,prefix,mode])
def process_marshal(self):
	for i in getattr(self,'marshal_lst',[]):
		env=self.env.copy()
		node=self.path.find_resource(i[0])
		if not node:
			raise Utils.WafError('file not found on gnome obj '+i[0])
		if i[2]=='--header':
			env['GGM_PREFIX']=i[1]
			env['GGM_MODE']=i[2]
			task=self.create_task('glib_genmarshal',env)
			task.set_inputs(node)
			task.set_outputs(node.change_ext('.h'))
		elif i[2]=='--body':
			env['GGM_PREFIX']=i[1]
			env['GGM_MODE']=i[2]
			outnode=node.change_ext('.c')
			self.allnodes.append(outnode)
			task=self.create_task('glib_genmarshal',env)
			task.set_inputs(node)
			task.set_outputs(node.change_ext('.c'))
		else:
			error("unknown type for marshal "+i[2])
def add_dbus_file(self,filename,prefix,mode):
	if not hasattr(self,'dbus_lst'):self.dbus_lst=[]
	self.meths.append('process_dbus')
	self.dbus_lst.append([filename,prefix,mode])
def process_dbus(self):
	for i in getattr(self,'dbus_lst',[]):
		env=self.env.copy()
		node=self.path.find_resource(i[0])
		if not node:
			raise Utils.WafError('file not found on gnome obj '+i[0])
		env['DBT_PREFIX']=i[1]
		env['DBT_MODE']=i[2]
		task=self.create_task('dbus_binding_tool',env)
		task.set_inputs(node)
		task.set_outputs(node.change_ext('.h'))
def process_enums(self):
	for x in getattr(self,'mk_enums',[]):
		env=self.env.copy()
		task=self.create_task('mk_enums',env)
		inputs=[]
		src_lst=self.to_list(x['source'])
		if not src_lst:
			raise Utils.WafError('missing source '+str(x))
		src_lst=[self.path.find_resource(k)for k in src_lst]
		inputs+=src_lst
		env['MK_SOURCE']=[k.abspath(env)for k in src_lst]
		if not x['target']:
			raise Utils.WafError('missing target '+str(x))
		tgt_node=self.path.find_or_declare(x['target'])
		if tgt_node.name.endswith('.c'):
			self.allnodes.append(tgt_node)
		env['MK_TARGET']=tgt_node.abspath(env)
		if x['template']:
			template_node=self.path.find_resource(x['template'])
			env['MK_TEMPLATE']='--template %s'%(template_node.abspath(env))
			inputs.append(template_node)
		task.set_inputs(inputs)
		task.set_outputs(tgt_node)
def add_glib_mkenum(self,source='',template='',target=''):
	if not hasattr(self,'mk_enums'):self.mk_enums=[]
	self.meths.append('process_enums')
	self.mk_enums.append({'source':source,'template':template,'target':target})
Task.simple_task_type('mk_enums','${GLIB_MKENUM} ${MK_TEMPLATE} ${MK_SOURCE} > ${MK_TARGET}','PINK',before='cc')
cls=Task.simple_task_type('sgml2man','${SGML2MAN} -o ${TGT[0].bld_dir(env)} ${SRC}  > /dev/null',color='BLUE')
cls.scan=sgml_scan
cls.sig_implicit_deps=sig_implicit_deps
cls.quiet=1
Task.simple_task_type('glib_genmarshal','${GGM} ${SRC} --prefix=${GGM_PREFIX} ${GGM_MODE} > ${TGT}',color='BLUE',before='cc')
Task.simple_task_type('dbus_binding_tool','${DBT} --prefix=${DBT_PREFIX} --mode=${DBT_MODE} --output=${TGT} ${SRC}',color='BLUE',before='cc')
Task.simple_task_type('xmlto','${XMLTO} html -m ${SRC[1].abspath(env)} ${SRC[0].abspath(env)}')
Task.simple_task_type('xml2po','${XML2PO} ${XML2POFLAGS} ${SRC} > ${TGT}',color='BLUE')
xslt_magic="""${XSLTPROC2PO} -o ${TGT[0].abspath(env)} \
--stringparam db2omf.basename ${APPNAME} \
--stringparam db2omf.format docbook \
--stringparam db2omf.lang C \
--stringparam db2omf.dtd '-//OASIS//DTD DocBook XML V4.3//EN' \
--stringparam db2omf.omf_dir ${PREFIX}/share/omf \
--stringparam db2omf.help_dir ${PREFIX}/share/gnome/help \
--stringparam db2omf.omf_in ${SRC[0].abspath(env)} \
--stringparam db2omf.scrollkeeper_cl ${SCROLLKEEPER_DATADIR}/Templates/C/scrollkeeper_cl.xml \
${DB2OMF} ${SRC[1].abspath(env)}"""
Task.simple_task_type('xsltproc2po',xslt_magic,color='BLUE')
def detect(conf):
	conf.check_tool('checks')
	sgml2man=conf.find_program('docbook2man',var='SGML2MAN')
	glib_genmarshal=conf.find_program('glib-genmarshal',var='GGM')
	dbus_binding_tool=conf.find_program('dbus-binding-tool',var='DBT')
	mk_enums_tool=conf.find_program('glib-mkenums',var='GLIB_MKENUM')
	def getstr(varname):
		return getattr(Options.options,varname,'')
	prefix=conf.env['PREFIX']
	datadir=getstr('datadir')
	libdir=getstr('libdir')
	sysconfdir=getstr('sysconfdir')
	localstatedir=getstr('localstatedir')
	if not datadir:datadir=os.path.join(prefix,'share')
	if not libdir:libdir=os.path.join(prefix,'lib')
	if not sysconfdir:
		if os.path.normpath(prefix)=='/usr':
			sysconfdir='/etc'
		else:
			sysconfdir=os.path.join(prefix,'etc')
	if not localstatedir:
		if os.path.normpath(prefix)=='/usr':
			localstatedir='/var'
		else:
			localstatedir=os.path.join(prefix,'var')
	conf.define('GNOMELOCALEDIR',os.path.join(datadir,'locale'))
	conf.define('DATADIR',datadir)
	conf.define('LIBDIR',libdir)
	conf.define('SYSCONFDIR',sysconfdir)
	conf.define('LOCALSTATEDIR',localstatedir)
	xml2po=conf.find_program('xml2po',var='XML2PO')
	xsltproc2po=conf.find_program('xsltproc',var='XSLTPROC2PO')
	conf.env['XML2POFLAGS']='-e -p'
	conf.env['SCROLLKEEPER_DATADIR']=Utils.cmd_output("scrollkeeper-config --pkgdatadir").strip()
	conf.env['DB2OMF']=Utils.cmd_output("/usr/bin/pkg-config --variable db2omf gnome-doc-utils").strip()
	conf.define('ENABLE_NLS',1)
	conf.define('HAVE_BIND_TEXTDOMAIN_CODESET',1)
	conf.define('HAVE_DCGETTEXT',1)
	conf.check_header('dlfcn.h','HAVE_DLFCN_H')
	conf.define('HAVE_GETTEXT',1)
	conf.check_header('inttypes.h','HAVE_INTTYPES_H')
	conf.check_header('locale.h','HAVE_LOCALE_H')
	conf.check_header('memory.h','HAVE_MEMORY_H')
	conf.check_header('stdint.h','HAVE_STDINT_H')
	conf.check_header('stdlib.h','HAVE_STDLIB_H')
	conf.check_header('strings.h','HAVE_STRINGS_H')
	conf.check_header('string.h','HAVE_STRING_H')
	conf.check_header('sys/stat.h','HAVE_SYS_STAT_H')
	conf.check_header('sys/types.h','HAVE_SYS_TYPES_H')
	conf.check_header('unistd.h','HAVE_UNISTD_H')
def set_options(opt):
	opt.add_option('--want-rpath',type='int',default=1,dest='want_rpath',help='set rpath to 1 or 0 [Default 1]')
	for i in"execprefix datadir libdir sysconfdir localstatedir".split():
		opt.add_option('--'+i,type='string',default='',dest=i)

taskgen(add_marshal_file)
taskgen(process_marshal)
before('apply_core')(process_marshal)
taskgen(add_dbus_file)
taskgen(process_dbus)
before('apply_core')(process_dbus)
taskgen(process_enums)
before('apply_core')(process_enums)
taskgen(add_glib_mkenum)
